#!/usr/bin/env python
# -*- coding: utf-8 -*-
#
#  constants.py
#  
#  Copyright 2019 Stefan Born <born@math.tu-berlin.de>
#  
#  This program is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation; either version 2 of the License, or
#  (at your option) any later version.
#  
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#  
#  You should have received a copy of the GNU General Public License
#  along with this program; if not, write to the Free Software
#  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
#  MA 02110-1301, USA.
#  
#  


 
MAPSIZE = 1200                             #Länge der Seite der Map
PLAYERCOUNT = int(0.05*MAPSIZE)            #Anzahl der generierten Kreaturen
FOODDENSITY = 0.0025                       #Menge der generierten Kreaturen 
TEMPRATURE = -2                            #Temperatur der Karte
START_STAMINA = 3000                       #Ausgangsausdauer der Kreaturen zu Beginn jeder Generation
FOOD_STAMINA = 2000                        #Ausgangsausdauer für die kreaturen bei aufnahme eines Futterstücks
MUTATIONSWAHRSCHEINLICHKEIT_VERHALTEN = 5  #Die Wahrscheinlichkeit der Mutation beträgt 1/verhalten_mutation_wahrscheinlichkeit
CHUNKANZAHL = 10                           #Die Wurzel der Anzahl der Chunks auf der gesamten Karte
STAMINA_KOEFFIZIENT = 20     #Die Ausdauer der Kreaturen kann maximal bei diesem Wert mal ihrer Start Ausdauer liegen
MIN_STAMINA_LOSS_PER_STEP = 5               #Die Kreaturen verlieren wenigstens so viel Stamina pro Schritt
MAX_DEATH = 5000                            #Maximal mögliche Anzahl an Schritten

CREATURE_GENERATION_PER_OLD_CREATURE = True  #Wenn True, werden Kreaturen in der nächsten Generation aus den alten generiert, mit bestimmten Regeln welche Kreatur wie viele Nachkommen zeugt, wenn False werden die besten Kreaturen (nach dauer des überlebens) als Vorbilder ausgewählt
SURVIVED_STEPS_FOR_CHILD = 1400            #Pro SURVIVED_STEPS_FOR_CHILD wird ein Nachkomme der Kreatur in der nächsten Generation erzeugt
COLLECTED_FOOD_FOR_CHILD = 5               #Pro COLLECTED_FOOD_FOR_CHILD wird ein Nachkomme der Kreatur in der nächsten Generation erzeugt
MIN_COLLECTED_FOOD = 2       #Eine Kreatur muss mindestens so viel Futter sammeln, um in der nächsten Generation Nachkommen zu generieren
MIN_SURVIVED_STEPS = 800     #Eine Kreatur muss mindestens so viele Schritte überleben, um in der nächsten Generation Nachkommen zu generieren

FOOD_GENERATION_PER_OLD_FOOD = True      #Wenn True, wird das Futter in der nächsten Generation aus dem überlebendem alten Futter generiert, wenn False wird jede Generation eine Anzahl an Futter entsprechend der FOODDENSITY generieren
FOOD_PER_GENERATION = 0.2    #FOODDENSITY mal diesem Wert entspricht der Wahrscheinlichkeit für die Generierung neuen Futters pro Generation


def main(args):
    return 0

if __name__ == '__main__':
    import sys
    sys.exit(main(sys.argv))
