#!/usr/bin/env python
# coding: utf-8

# In[1]:


import random
import pygame
import time
import copy
import matplotlib.pyplot as plt
import math

from constants import *
from player import RandomPlayer as Player  # Hier lässt sich auch ein anderer Player importieren


class Object:

    #Initialisiert das Objekt
    def __init__(self,x,y,name):
        self.x=x #x-Pos
        self.y=y #y-Pos
        self.status = True #Aktiv oder nicht
        self.name = name #ID
        self.chunkpos = [] #Speichert die Koordinaten des Chunks
        self.size = random.randint(3,5) #Größe
        self.rect = pygame.Rect(self.x, self.y, self.size,self.size) #Rechteck in Pygame
        self.stamina=FOOD_STAMINA*self.size
        
    #Mutiert die Objekte
    def mutate(self,xmin,xh):
        self.size=self.size+random.choice(range(-9,10))*0.01  #Mutiert Größe
        self.x=self.x+random.choice(range(xmin,xmin+xh))      #legt x und 
        if self.x<0:
            self.x=self.x*(-1)
        self.y=self.y+random.choice(range(xmin,xmin+xh))      #y in der Nähe der Werte des Vorbilds fest
        if self.y<0:
            self.y=self.y*(-1)
        self.rect = pygame.Rect(self.x, self.y, self.size,self.size)  
    
    #zeichnen der Objekte (Wird gerade nicht benutzt)
    def draw(self):
        pygame.draw.rect(screen, (255, 0, 255), self.rect)   
        
    #Löscht das Objekt
    def __del__(self):
        a=0

#Klasse Chunk
class Chunk:
    x = 0 #x-Position
    y = 0 #y-Position
    food=0 #???
    length = 0 #Länge(x-Richtung)
    height = 0 #Breite(y-Richtung
    overlay = 0 #Wie stark sich die verschiedenen Chunks überlappen
    name = 0 # ID
    
    #Initilisiert den Chunk
    def __init__(self,x,y,length,height,overlay,name):
        self.x = x
        self.y = y
        self.length = length
        self.height = height
        self.overlay = overlay
        self.objects = [] #Liste der festen Objekte
        self.density = FOODDENSITY #Wahrscheinlichkeit für neue Objekte        
        self.name = name
        self.numb = self.length*self.height*self.density/4
    
    #Fügt der Objektliste ein neues Element hinzu
    def newobj(self,obj):
        self.objects.append(obj)        

    #Übergibt die maximale x-Position
    def getendx(self):
        return self.x+self.length

    #Übergibt die maximale y-Position
    def getendy(self):
        return self.y+self.height

    #löscht das Objekt
    def __del__(self):
        a = 0
    
    #generiert zufällig verteilte Objekte in dem Chunk
    def generate(self,multi=1):
        a = Object(0,0,0)
        numb = self.length*self.height*self.density/a.size*multi
        for i in range(int(numb)):
                    self.objects.append(Object(random.randint(self.x+int(self.height*0.1),self.getendx()-int(self.height*0.1)-a.size),random.randint(self.y+int(self.height*0.1),self.getendy()-int(self.height*0.1)-a.size),i))
                    
    #print(len(self.objects))
    def color(self,num,num2):
        colorlist = []
        if num == 1:
            for i in range(num2+1):
                colorlist.append((6*i,255-8*i,2*i))
                colorlist.append((34-i,139+i*4,34+i))
                colorlist.append((10*i,128-i*2,0+i))
                colorlist.append((9*i,100+i*7,2*i))
        elif num == 2:
            colorlist.append((0,0,0))
        elif num == 3:
            colorlist.append((0,0,0))
        else:
            for i in range(20):
                colorlist.append((0,255-i,0))
                colorlist.append((34-i,139+i,34+i))
                colorlist.append((0,128-i,255+i*20))
                colorlist.append((10*i,100+i,20*i))
        a = 110351524512345
        c = 12345
        #print(self.x)
        #print(self.y)
        #print("hi")
        e=0
        while e < self.length:
            i=0
            while i< self.height:
                number = (a*(e+i)+c)%2**31
                q=1
                k = ((e+1)*(a+number)+c)%2**31
                rect=pygame.Rect((self.x+i,self.y+e,5,5))
                while q<(len(colorlist)+1):
                    
                    if (q-1)*2**31/len(colorlist)<=k<q*2**31/len(colorlist):
                        pygame.draw.rect(screen, colorlist[q-1],rect)
                        break
                    q+=1
                i+=5
            e+=5


#Gesamte Map
class Map:
    objects = 0
    worldsize = 0 
    chunksize = 0
    overlay = 0
    
    #Initilisiert die Map
    #def__init__(Liste der Objekte,Liste der Spieler,Gesamtgröße der Map,Größe der Chunks)
    def __init__(self,playerlist,size,sizechunk,old_objects):
        self.worldsize = size #Worldsize
        self.chunksize = sizechunk #Chunksize wird später static
        self.overlay = sizechunk*0.2 #Overlay der Chunks(10%)
        self.player = playerlist #Spielerliste
        for player in self.player:
            player.world = self
        self.faktor = int(size/sizechunk) #Faktor(für einige Berechnungen)
        self.maplist = [] #2-Dim Liste der Chunks
        self.initiate(old_objects)
        self.playerupdate()
    
    #Initilisiert die Grundmap, sowie weist jedem Chunk die Objekte hinzu
    def initiate(self,old_objects):
        factor = int(self.worldsize/self.chunksize)
        #print(factor)
        R = 0
        a=0
        u=0
        #Durchläuft die y-Richtung der Chunks
        for i in range(factor):
            line = []
            a+=1
            qqq = 110351524512345
            qqqq = 12345
            #Durchläuft die x-Richtung der Chunks
            for e in range(factor): 
                u+=1
                line.append(Chunk(self.chunksize*e,self.chunksize*i,self.chunksize,self.chunksize,self.overlay,e+i*factor))
                #Wenn entsprechend eingestellt, wird Futter in der Umgebung des überlebenden Futters aus der letzten Runde generiert
                if FOOD_GENERATION_PER_OLD_FOOD:
                    if old_objects==0:     #Für die erste Runde wird in jedem Chunk entsprechend Futter generiert
                        line[e].generate()
                    else:       
                        objects=[]   #die Liste der zu kopierenden Objekte in dem Chunk
                        for o in old_objects:
                            if o.x<self.chunksize*(e+1) and o.y<self.chunksize*(i+1):
                                if o.x>=self.chunksize*e and o.y>=self.chunksize*i:
                                    objects.append(o)
                        #kopiere die Objekte so oft, wie es der geamten Anzahl der Objekte angemessen ist
                        for o in objects:
                            if (MAPSIZE/CHUNKANZAHL)<len(objects):
                                N=random.randint(0,2)
                            elif (MAPSIZE/CHUNKANZAHL)/2<len(objects):
                                N=random.randint(0,4)
                            else:
                                N=random.randint(0,6)
                            n=0

                            while n<N:
                                ob=copy.copy(o)
                                ob.mutate(-20,40)
                                line[e].objects.append(ob)

                                n+=1
                        #Füge in jedem Chunk noch mal eine kleine Anzahl Objekte hinzu
                        line[e].generate(FOOD_PER_GENERATION)
                
                else:
                    if random.random()<0.7:
                        line[e].generate()
                
            self.maplist.append(line)
            del line
        
        print("Objects ready!")
        print("")
    
    #weist jedem Spieler den Chunk hinzu in welchem dieser sich befindet
    def playerinitiate(self,playerlist):
        self.player = playerlist
        #Durchläuft die Liste der Player
        for q in range(len(self.player)):
            #Durchläuft die x-Richtung der Chunks
            for i in range(len(self.maplist)):
                qq = False
                #Durchläuft die y-Richtung der Chunks
                for e in range(len(self.maplist[i])):
                    if self.maplist[i][e].x <= self.player[q].x <= self.maplist[i][e].getendx() and self.maplist[i][e].y <= self.player[q].y <= self.maplist[i][e].getendy():
                        self.player[q].chunkpos.append(i)
                        self.player[q].chunkpos.append(e)
                        qq = True
                        break
                if qq == True:
                    break
        print("Player Ready!")
    
    #überprüft die Chunkposition des Spielers
    def playerupdate(self):

        #Durchläuft die Liste der Player
        q=0
        while q < len(self.player):

            #Chunkposition in der Liste
            i = self.player[q].chunkpos[0]
            e = self.player[q].chunkpos[1]
        
            x = self.player[q].x #x-Pos des Spielers
            y = self.player[q].y #y-Pos des Spielers
            x0 = 0 #kleinste x-Pos der Chunks
            y0 = 0 #kleinste y-Pos der Chunks
            xn = self.worldsize #größte x-Pos der Chunks
            yn = self.worldsize #größte x-Pos der Chunks
            
            
            if x <= x0 or x >= xn or y <= y0 or y >= yn:
                self.player[q].alive=False
            else:
                #Da sich die Map auch in den negativen Bereich erweitert, erhalten alle Chunks einen Shift.
                self.player[q].chunkpos[1] = int(x/self.chunksize)
                self.player[q].chunkpos[0] = int(y/self.chunksize)
                #print(x,"/",y)             
                #print(self.maplist[int(y/self.chunksize)][int(x/self.chunksize)].x,"/",self.maplist[int(y/self.chunksize)][int(x/self.chunksize)].y)
                #print("---------")
                #time.sleep(2)
            q+=1
    #Hitboxberechung der Objekte und den Spielern
    def hitbox(self):
        #Durchläuft jeden Spieler
                        
            
        for p in self.player:  #erstellt eine liste, in der alle Objekte des Chunks des Spielers und der Umgebenden Chunks gespeichert sind
            if p.alive:
                obj_list=[]
                q = p.chunkpos[0]
                w = p.chunkpos[1]
                #Fügt der Liste Objekte aus Chunks zu, welche an den Chunk des spielers angrenzen 
                #und nicht außerhalb der Map liegen
                for ob in self.maplist[q][w].objects:
                    obj_list.append(ob)

                if q-1>=0:
                    for ob in self.maplist[q-1][w].objects:
                        obj_list.append(ob)
                    if w-1>=0:
                        for ob in self.maplist[q-1][w-1].objects:
                            obj_list.append(ob)

                if w-1>=0:
                    for ob in self.maplist[q][w-1].objects:
                        obj_list.append(ob)
                    if q+1<int(self.worldsize/self.chunksize):
                        for ob in self.maplist[q+1][w-1].objects:
                            obj_list.append(ob)

                if q+1<int(self.worldsize/self.chunksize):
                    for ob in self.maplist[q+1][w].objects:
                        obj_list.append(ob)
                    if w+1<int(self.worldsize/self.chunksize):
                        for ob in self.maplist[q+1][w+1].objects:
                            obj_list.append(ob)

                if w+1<int(self.worldsize/self.chunksize):
                    for ob in self.maplist[q][w+1].objects:
                        obj_list.append(ob)
                    if q-1<=0:
                        for ob in self.maplist[q-1][w+1].objects:
                            obj_list.append(ob)

                #überprüft die Objekte der Liste auf ihre erreichbarkeit in einem Schritt und ob sie noch nicht gefressen wurden
                for ob in obj_list:
                    if (p.x-ob.x)**2+(p.y-ob.y)**2<(p.speed*10)**2 and ob.status:
                        #Prüft dann, ob der Spieler mit dem Objekt kollidiert
                        if p.rect.colliderect(ob.rect):  
                            #Frißt dann das Objekt
                            ob.status = False

                            p.stamina+=ob.stamina
                            p.collected_food+=1

    #Gibt die Liste der Spieler aus
    def showp(self):
        for i in range(len(self.player)):
            q = self.player[i].chunkpos[0]
            w = self.player[i].chunkpos[1]
            a=len(self.maplist[q][w].objects)
            #Durchläuft die Liste der Objekte im Chunk mit den der Spieler kollidieren kann
            print("Player",i)
            #print("Anzahl der Objekte:",len(self.maplist[q][w].objects))
            

    #Gibt die Liste der Objekte aus
    def showc(self):
        #Durchläuft die Liste der Chunks
        print(len(self.maplist))
        for i in range(len(self.maplist)):
            print(len(self.maplist[i]))
            for e in range(len(self.maplist[i])):
                #Gibt die Koordinaten des Objektes aus
                print("(",self.maplist[i][e].x,"/",self.maplist[i][e].y,") - ","(",self.maplist[i][e].getendx(),"/",self.maplist[i][e].getendy(),")")
                print(1,len(self.maplist[i][e].objects))

    #Zeichnet alle Objekte auf dem Hauptbildschirm 
    def drawobj(self):
        for q in self.maplist:
            for w in q:
                for i in w.objects:
                    if i.status:
                        pygame.draw.rect(screen, (255, 0, 255), i.rect)
                        
    #Zeichnet die Chunks in einem weiteren Bildschirm
    def drawchunks(self):
        for q in self.maplist:
            for w in q:
                pygame.draw.rect(screen, (255, 0, 255), i.rect)

    #erweitert die Karte falls ein Spieler außerhalb der derzeitigen Karte ist
    def map_increase(self,pos):

        #erweitert die Karte nach links
        if (self.player[pos].x<self.maplist[0][0].x):
            #print(self.player[pos].x,"<",self.maplist[0][0].x)
            i = 0
            k = self.maplist[0][0].x-self.chunksize
            l = self.maplist[0][0].y
            for list in self.maplist:
                list.insert(0,chunk(k,l+i*self.chunksize,self.chunksize,self.chunksize,self.overlay,5))#neuer Chunk
                list[0].generate(2,random.randint(0,5),random.randint(0,5),len(self.objects)) #chunk generiert
            value = True
            print("Map wird nach links erweitert.")

        #erweitert die Karte nach rechts
        if (self.player[pos].x>self.maplist[0][len(self.maplist[0])-1].getendx()):
            #print(self.player[pos].x,">",self.maplist[0][len(self.maplist[0])-1].getendx())
            i = 0
            k = self.maplist[0][len(self.maplist[0])-1].x+self.chunksize
            l = self.maplist[0][0].y
            for list in self.maplist:
                list.append(chunk(k,l+i*self.chunksize,self.chunksize,self.chunksize,self.overlay,5))
                list[len(list)-1].generate(2,random.randint(0,5),random.randint(0,5),len(self.objects))
                i+=1
            self.maplist.append(list)
            value = True
            print("Map wird nach rechts erweitert.")

        #erweitert die Karte nach unten
        if (self.player[pos].y<self.maplist[0][0].y):
            #print(self.player[pos].y,"<",self.maplist[0][0].y)
            i = 0
            k = self.maplist[0][0].x
            l = self.maplist[0][0].y-self.chunksize
            list = []
            for i in range(len(self.maplist[0])):
                list.append(chunk(k+i*self.chunksize,l,self.chunksize,self.chunksize,self.overlay,5))#neuer Chunk
                list[0].generate(2,random.randint(0,5),random.randint(0,5),len(self.objects))
                i+=1
            value = True
            self.maplist.insert(0,list)
            print("Map wird nach unten erweitert.")

        #erweitert die Karte nach oben
        if (self.player[pos].y>self.maplist[len(self.maplist)-1][len(self.maplist[len(self.maplist)-1])-1].getendy()):
            #print(self.player[pos].y,">",self.maplist[len(self.maplist)-1][len(self.maplist[len(self.maplist)-1])-1].getendy())
            i = 0
            k = self.maplist[0][0].x
            l = self.maplist[len(self.maplist)-1][len(self.maplist[len(self.maplist)-1])-1].y+self.chunksize
            list = []
            for i in range(len(self.maplist[0])):
                list.append(chunk(k+i*self.chunksize,l,self.chunksize,self.chunksize,self.overlay,5))
                list[i].generate(2,random.randint(0,5),random.randint(0,5),len(self.objects))
                i+=1
            self.maplist.append(list)
            value = True
            print("Map wird nach oben erweitert.")
    
    def get_info(self,player):
        '''should return some information on the environment of player,
        for generality in form of a dictionary'''

        q = player.chunkpos[0]
        w = player.chunkpos[1]
        close_object_list=[]
        #Falls die Liste leer ist
        for ob in self.maplist[q][w].objects:
            if ob.status:
                if (player.x-ob.x)**2+(player.y-ob.y)**2<player.speed**2:
                    close_object_list.append(ob)
        
        return close_object_list
        
    
    #Reset für die nächste Generation
    def nextstage(self,playerlist):
        self.maplist.clear()
        self.player.clear()
        self.initiate()
        self.playerinitiate(playerlist)

    
    def get_number_of_living_players(self):
        return sum([1 for player in self.player if player.alive])

def simulate_one_round(playerl,objects):
    global screen
    
    clock = pygame.time.Clock()

    map01 = Map(playerl,MAPSIZE,MAPSIZE//CHUNKANZAHL,objects)#erstellt die Map

    moveframes = 5 #Anzahl der Frames
    runde = 0 #Zählt die Schleifendurchläufe
    done = False #Falls True beendet das Programm
    winner = []
    while not done:
        #clock.tick(50) #Für größere Pausen zwischen den Runden

        #Beendet das Programm falls ...
        for event in pygame.event.get():
            if event.type == pygame.QUIT:
                done =True

        screen.fill((0,255,0)) #Setzt die Hintergrundfarbe
        map01.playerupdate() #Überprüft alle Spieler auf ihren Chunk
        map01.hitbox() #Überprüft die Hitbox zu allen Objekten in diesem Chunk
        map01.drawobj() #Zeichnet alle Objekte
        for player in playerl:
            if player.stamina<0:
                player.alive=False
        
        #Zeichnet den Spieler mit einer Farbe, abhängig von dem Ausdauer des spielers
        for player in playerl:
            if player.alive:
                if player.stamina<player.max_stamina:
                    b=255-255/(player.max_stamina)*player.stamina
                    
                else:
                    b=0
                    
                
                pygame.draw.rect(screen, (0,b,b),player.rect)
        
        
        #Bewege die Spieler
        for player in map01.player:
            if player.alive:
                player.move()
                
        #Bei keine Spieler wird das Programm beendet
        if map01.get_number_of_living_players()==0:
            
            break
        

        pygame.display.flip()
        #time.sleep(20)
        runde += 1

    
    print("Eine Simulationsrunde ist beendet")#Programm ist beendet
    return map01


#Statistic-Objekte enthalten die Listen für die minima, die durchschnittlichen und die maxima Werte der jeweiligen Eigenschaft
class statistic:
    list_min=[]
    list_average=[]
    list_min=[]
    
    def __init__(self,name): 
        self.list_min=[]
        self.list_average=[]
        self.list_max=[]
        self.name=name        #name ist die entsprechende betrachtete Eigenschaft
        
    #eingabe fügt jede Generation den größten, kleinsten und durchschnittlichen Wert der betrachteten Eigenschaft
    def eingabe(self,creature_list):
        all_values=[]     #Liste für alle Werte der Eigenschaft in einer Generation
        sum_all_values=0  #die Summe aller Werte der Eigenschaft in einer Generation
        
        for p in creature_list:
            all_values.append(getattr(p,self.name))
            
        self.list_min.append(min(all_values))
        self.list_max.append(max(all_values))
        for v in all_values:
            sum_all_values=sum_all_values+v
        self.list_average.append(sum_all_values/len(creature_list))
        
    def plot(self,generation_list,a):  #plotten der Graphen der Statistiken
        plt.figure(a)
        plt.plot(generation_list,self.list_min)
        plt.plot(generation_list,self.list_max)
        plt.plot(generation_list,self.list_average)
        plt.title(self.name)
        
    
    
    
# --------------------------------------------------------------------------
# --------------------------------------------------------------------------
#  ------------  EVOLUTION --------------------------------------------------

def make_first_generation():
    playerl = [] #Spielerliste
    for i in range(PLAYERCOUNT):#erstellt X Spieler
        playerl.append(Player(random.randint(MAPSIZE*0.1,MAPSIZE*0.9),random.randint(MAPSIZE*0.1,MAPSIZE*0.9),0,i))
        playerl[-1].mutate(initial=True)
        playerl[-1].movement_parameters(initial=True)
    
    return playerl
        
        

def make_selected_and_mutated_generation(playerl,reduce_generation = 10):
    if CREATURE_GENERATION_PER_OLD_CREATURE:
        possible_player=[]
        new_playerl = []
        for player in  playerl: #erstellt liste mit Kreaturen, welche die Fortpflanzungskriterien erfüllen
            if player.collected_food>=MIN_COLLECTED_FOOD and player.survived_steps>MIN_SURVIVED_STEPS:
                possible_player.append(player)
        for player in possible_player: #erstellt aus diesen Kreaturen mutierte Kopien der Kreaturen, entsprechend ihrer Werte
            s=0
            f=0
            while f<player.collected_food:
                newplayer = copy.copy(player)
                newplayer.chunkpos = [0,0]
                newplayer.color = (27,27,27)
                newplayer.alive = True
                newplayer.dist = []
                newplayer.fit = 0
                newplayer.survived_steps = 0
                newplayer.total_stamina = 0  
                newplayer.set_start_position(random.randint(MAPSIZE*0.1,MAPSIZE*0.9),random.randint(MAPSIZE*0.1,MAPSIZE*0.9))
                newplayer.past = [[],[],[]]
                newplayer.mutate()
                newplayer.movement_parameters()
                new_playerl.append(newplayer)
                f+=COLLECTED_FOOD_FOR_CHILD

            while s<player.survived_steps:
                newplayer = copy.copy(player)
                newplayer.chunkpos = [0,0]
                newplayer.color = (27,27,27)
                newplayer.alive = True
                newplayer.dist = []
                newplayer.fit = 0
                newplayer.survived_steps = 0
                newplayer.total_stamina = 0 
                newplayer.set_start_position(random.randint(MAPSIZE*0.1,MAPSIZE*0.9),random.randint(MAPSIZE*0.1,MAPSIZE*0.9))
                newplayer.past = [[],[],[]]
                newplayer.mutate()
                newplayer.movement_parameters()
                new_playerl.append(newplayer)
                s+=SURVIVED_STEPS_FOR_CHILD

        print("player",len(new_playerl))   
        return new_playerl

    else:  #erstellt eine feste Anzahl an Kreaturen, sollte es entsprenchen in constatns festgelegt sein
        playerl.sort(key = lambda player: -player.survived_steps)
        possible_player=[]
        new_playerl = []
        print("mut",len(playerl))
        for player in  playerl:
            if player.collected_food!=0:
                possible_player.append(player)
        for player in possible_player[:int(PLAYERCOUNT/reduce_generation)]:
            for i in range(reduce_generation):
                newplayer = copy.copy(player)
                newplayer.alive = True
                newplayer.survived_steps = 0
                newplayer.stamina = START_STAMINA
                newplayer.collected_food = 0
                newplayer.mutate()
                newplayer.movement_parameters()

                newplayer.set_start_position(random.randint(MAPSIZE*0.1,MAPSIZE*0.9),random.randint(MAPSIZE*0.1,MAPSIZE*0.9))
                new_playerl.append(newplayer)
        print(len(new_playerl))        
        return new_playerl
    
    
a=0
while a<1: #Anzahl der Durchläufe des Programms
    
    if __name__=="__main__":
        n=0                        #Generationen -Zähler
        best=0                     #Zähler für die am längsten überlebende Kreatur
        list_generation_number=[]  #Liste für die Generationennumber
        
        pygame.init()
        screen = pygame.display.set_mode((MAPSIZE,MAPSIZE)) #erstellt den Hauptbildschirm
        
        playerl = make_first_generation()
        
        survived_objects=0  #für die erste Generation Kennzeichen, dass es noch keine vorherige Objekte gibt
        #für spätere Generationen eine Liste mit den überlebenden Objekten
        
        list_menge=[]         #Liste der anzahl der Kreaturen in jeder Generation
        list_object_menge=[]  #Liste der anzahl der Objekte in jeder Generation
        
        #erstellen von Objekten für Statistiken
        speed_statistic=statistic("speed")
        size_statistic=statistic("size")
        sight_statistic=statistic("sight")
        fat_statistic=statistic("fat")
        survived_steps_statistic=statistic("survived_steps")


        while n<1:  #Anzahl der mximal betrachteten Generationen
        #while True:
            
            list_generation_number.append(n)
            
            map01 = simulate_one_round(playerl,survived_objects)
            
            #Menge der Objekte auf der Map
            ob_menge=0
            for l in map01.maplist:
                for c in l:
                    for o in c.objects:
                        ob_menge+=1
            
            
            list_object_menge.append(ob_menge)
            list_menge.append(len(map01.player))
            
            #Einfügen der Werte in die Statistiken    
            speed_statistic.eingabe(map01.player)
            size_statistic.eingabe(map01.player)
            sight_statistic.eingabe(map01.player)
            fat_statistic.eingabe(map01.player)
            survived_steps_statistic.eingabe(map01.player) 
            
            
            n+=1
            #sucht den besten Spieler über alle Generationen
            for pl in map01.player:
                pl.generation=n
                if pl.survived_steps>best:
                    best_player=pl
                    best_player_generation=n
                    best_player_round=a
                    best=pl.survived_steps
                    
            playerl = make_selected_and_mutated_generation(playerl)
            
            if playerl == []:
                print("Das Leben hat keinen Weg gefunden!")
                break
            
                    
            survived_objects=[]
            
            #fügt den survived objects die überlebenden Objekte zu
            for l in map01.maplist:
                for c in l:
                    for o in c.objects:
                        if o.status:
                            survived_objects.append(o)
            survived_objects.sort(key = lambda o: -o.x)
            
            
            print("Runde:",a,"  Generation:",n)
            print(len(survived_objects))
            print("-----")
      
    #Plotten der Graphen
    b=a*2
    
    plt.figure(b)
    plt.subplot(221)
    speed_statistic.plot(list_generation_number,b)
    plt.subplot(222)
    size_statistic.plot(list_generation_number,b)
    plt.subplot(223)
    sight_statistic.plot(list_generation_number,b)
    plt.subplot(224)
    fat_statistic.plot(list_generation_number,b)
    
    b+=1
    plt.figure(b)
    plt.subplot(221)
    survived_steps_statistic.plot(list_generation_number,b)
    plt.subplot(222)
    plt.plot(list_generation_number,list_menge)
    plt.subplot(223)
    plt.plot(list_generation_number,list_object_menge)
    
    a+=1

print("Bester Spieler:")
print("Runde",best_player_round,"Generation",best_player_generation)
print("Speed",best_player.speed, " Size",best_player.size, " Sight",best_player.sight)
  
    
plt.show


# In[ ]:





# In[ ]:





# In[ ]:




